# This file originally contained the comment:
#   Do not edit -- this file automatically generated by build_v3_dist.
# On the contrary, do not rerun build_v3_dist, this file contains
# custom changes for LSB that should not be overwritten
# upstream (gcc) version, LSB specification version, LSB release version

# NOTE: When uplifting to a new upstream version, it is very likely that
# the contents of exe-files.txt, compiler-tests.txt, and 
# known-build-fails.txt will need to be reviewed/revised

# %{ver}, %{rel}, %{LSBRelease}, %{LSBSpec}  provided by Makefile
%define ver 4.1.0
%define rel 13
%define LSBRelease 4
%define LSBSpec 4.0

# expected passes
%define shouldpass 1790

# set these to zero to skip compiler-tests.txt, known-build-fails.txt filters
%define knownfails 1
%define nocompiler 1
# set this to zero to not fail the build on missing tests from exe-files.txt
%define exefails 1
 
Summary:     libstdcpp-v3 testsuite packaged to be run under QMTest.
Name:        lsb-test-libstdcpp
Packager:    Nathaniel Smith <njs@codesourcery.com>
License:     Various
# This should be the gcc version
Version:     %{ver}
Release:     %{rel}.lsb%{LSBRelease}
Group:       Development/Tools
BuildRoot:   %{_tmppath}/%{name}-buildroot
Source:      lsb-test-libstdcpp-%{version}.tar.gz
Source1:     gcc-g++-%{ver}.tar.bz2
Patch0:      abi_check.patch
Patch1:      lsb-test-libstdcpp-3.4.3-nostdc++-dot-h.patch
Patch2:      lsb-test-libstdcpp-4.1.0-diff-from-upstream.patch
Patch3:      lsb-test-libstdcpp-4.1.0-bug-2445.patch
Patch4:      lsb-test-libstdcpp-4.1.0-bug-2596.patch
Patch5:      lsb-test-libstdcpp-4.1.0-bug-2640.patch
Patch6:      lsb-test-libstdcpp-4.1.0-gcc43.patch
Patch7:      lsb-test-libstdcpp-4.1.0-bug-2943.patch
Vendor:      CodeSourcery LLC
# If we let RPM detect dependencies, it will get the idea that this package
# requires a specific version of libstdc++.so, and that is unhelpful:
AutoReqProv: no
#Prefix: /opt/lsb/test
Requires: lsb-qm
BuildRequires: lsb-qm
Obsoletes: qmtest_libstdcpp
Provides: qmtest_libstdcpp

%description
This package includes the libstdc++-v3 testsuite from gcc version
%{version}, together with QMTest extensions allowing the testsuite
to be run against an installed version of libstdc++ without
requiring a compiler.

Expected test results:
Total Tests Passed: %{shouldpass}

%prep
%setup -q

# (sb) drop in the upstream source bits
for subdir in config/abi po scripts testsuite; do
  tar --strip-components=2 -xf %{SOURCE1} gcc-%{ver}/libstdc++-v3/$subdir
done

# (sb) now we can patch
%patch0 -p1 -b .abi_check

# (sb) some archs (ia64 for one) do not like "-include bits/stdc++.h"
# build log is full of errors of duplicate definitions - get 90-some tests
# apply to all archs and see of we break anything
%patch1 -p1 -b .no-stdc++-dot-h

# (sb) using upstream source now, apply the diff culled from our bzr
# abbreviated even more as of 4.1.0 bump
%patch2 -p0 -b .lsb

# bug 2445 - trailing "." in abbreviated dayofweek names in fr_FR locale
# causing FAILs - backport from 4.3.2 and use es_ES for the tests
%patch3 -p0 -b .bug-2445

# bug 2596 - change in behavior in newer glibc, pulled from upstream svn
%patch4 -p0 -b .bug-2596

# bug 2640 - tests are failing against 4.4.x, backport/adapt from upstream svn
%patch5 -p0 -b .bug-2640

# backward header tests fail to build under gcc-4.3, modify the #include
%patch6 -p0 -b .gcc43

# bug 2943 - tests failing on new distros, pull changes from upstream
%patch7 -p0 -b .bug-2943

# (sb) with the bump to 4.1.0, our {ppc,ppc64}-linux-gnu/baseline_symbols.txt 
# files are out of date, upstream has {powerpc,powerpc64}-linux-gnu, use those
cp config/abi/powerpc-linux-gnu/baseline_symbols.txt config/abi/ppc-linux-gnu
cp config/abi/powerpc64-linux-gnu/baseline_symbols.txt config/abi/ppc64-linux-gnu

%build
# do not used the precompiled stdc++.h
# alternate approach to P1 - uncomment the 2 lines below, comment out P1
#mkdir testsuite/bits
#touch testsuite/bits/stdc++.h

%if %{knownfails}
# (sb) there are a set of tests that always fail the build, with references
# to undefined reference to `__gnu_debug::...'. Since these always appear
# and are basically "noise" when trying to diagnose build issues, filter
# them out up front (this is not new - was present with 3.2 also)
# An additional set fail with variations of exceptions.AttributeError: _DG*
# A breakdown of the categories is in known-build-fails.txt
for cc in `grep -v '^#' known-build-fails.txt`;do
  if [ -n "$cc" ];then
    rm -f testsuite/$cc
  fi
done
%endif

# (sb) preferred method would be to get qmtest to handle these 
# new dg-foo features - workaround for now

# dg-xfail-if
for target in `grep -v '^#' dg-xfail-if.txt`;do
  if [ -f testsuite/$target ];then
# (sb) this did not work
#    sed -i 's|// { dg-xfail-if "" { "*-*-hpux11.23" } { "*" } { "" } } */||g' testsuite/$target
    sed -i 's|dg-xfail-if||g' testsuite/$target
  fi
done

# dg-require-namedlocale
for target in `grep -v '^#' dg-require-namedlocale.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-namedlocale "" }||g' testsuite/$target
  fi
done

# dg-require-cxa-atexit
for target in `grep -v '^#' dg-require-cxa-atexit.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-cxa-atexit "" }||g' testsuite/$target
  fi
done

# dg-require-debug-mode
for target in `grep -v '^#' dg-require-debug-mode.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-debug-mode "" }||g' testsuite/$target
  fi
done

# dg-require-fork
for target in `grep -v '^#' dg-require-fork.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-fork "" }||g' testsuite/$target
  fi
done

# dg-require-mkfifo
for target in `grep -v '^#' dg-require-mkfifo.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-mkfifo "" }||g' testsuite/$target
  fi
done

# dg-require-sharedlib
for target in `grep -v '^#' dg-require-sharedlib.txt`;do
  if [ -f testsuite/$target ];then
    sed -i 's|// { dg-require-sharedlib "" }||g' testsuite/$target
  fi
done

# testsuite_shared.so will not be in ./
%ifarch ppc64 s390x x86_64
sed -i "s|./testsuite_shared.so|/opt/lsb/test/lib64/libstdcpp_%{version}/testsuite_shared.so|g" testsuite/ext/mt_allocator/22309_thread.cc
%else
sed -i "s|./testsuite_shared.so|/opt/lsb/test/lib/libstdcpp_%{version}/testsuite_shared.so|g" testsuite/ext/mt_allocator/22309_thread.cc
%endif

%if %{nocompiler}
# compiler tests - do not bother with these either, end up as UNTESTED
# we were doing this post-build for LSB 3.2, just remove them up front
for cc in `grep -v '^#' compiler-tests.txt`;do
  if [ -n "$cc" ];then
    rm -f testsuite/$cc
  fi
done
%endif

# Even though we dropped this set of tests from exe-files.txt, they still
# get built/installed when built on an older system. For consistency, remove
# the source files altogether
for cc in `grep -v '^#' gcc43-drops.txt`;do
  if [ -n "$cc" ];then
    rm -f testsuite/$cc
  fi
done

%install
rm -rf $RPM_BUILD_ROOT

cat > README.%{name} << EOF
Before running the test script, please figure out the triplet for the
system under test. Normally you can use "gcc -dumpmachine" to get this.
The test script will make a guess which is probably okay, correct it
if it is not.  This step cannot be automated as a compiler is not
required in the test environment and other methods are imprecise.
After this, you can run the test by executing 
/opt/lsb/test/libstdcpp_%{version}/run_tests
EOF

# for bugid 982
mv qm-classes/qmtest_gcc/v3_database.py qm-classes/qmtest_gcc/v3_database.py.SAV
sed -e "s/return result + \[\"v3_abi_test\"]/return result/" qm-classes/qmtest_gcc/v3_database.py.SAV > qm-classes/qmtest_gcc/v3_database.py
rm -f qm-classes/qmtest_gcc/v3_database.py.SAV

# We do the building first, because some of the files generated will be
# installed later.
PATH=$PATH:/opt/lsb/bin:/opt/lsb/appbat/bin
PKGROOT=/opt/lsb/test/libstdcpp_%{version}
%ifarch ppc64 s390x x86_64
  EXECROOT=/opt/lsb/test/lib64/libstdcpp_%{version}
%else
  EXECROOT=/opt/lsb/test/lib/libstdcpp_%{version}
%endif
LIBDIR=$RPM_BUILD_ROOT/$EXECROOT
mkdir -p `dirname $LIBDIR`
export LSBCC_BESTEFFORT=1
./build_binary_testsuite $LIBDIR lsbc++ %{_sourcedir} 2>&1 | tee BUILD-DETAILS

SHAREDIR=$RPM_BUILD_ROOT/$PKGROOT
mkdir -p $SHAREDIR
for thing in `cat share-contents`; do
    if [ -d "$thing" ]; then
        cp -r "$thing" "$SHAREDIR/$thing"
    else
        cp "$thing" "$SHAREDIR/$thing"
    fi
done

%ifarch %{ix86}
triplet=i486-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc
triplet=ppc-unknown-linux-gnu
archlib=lib
%endif
%ifarch ppc64
triplet=ppc64-unknown-linux-gnu
archlib=lib64
%endif
%ifarch s390
triplet=s390-unknown-linux-gnu
archlib=lib
%endif
%ifarch s390x
triplet=s390x-unknown-linux-gnu
archlib=lib64
%endif
%ifarch ia64
triplet=ia64-unknown-linux-gnu
archlib=lib
%endif
%ifarch x86_64
triplet=x86_64-unknown-linux-gnu
archlib=lib64
%endif

# Create the run_tests file
sed -e "s\\^VERSION=$\\VERSION=%{version}\\" -e "s\\^ARCHLIB=$\\ARCHLIB=$archlib\\" run_tests.in > ${RPM_BUILD_ROOT}/$PKGROOT/run_tests
chmod a+x ${RPM_BUILD_ROOT}/$PKGROOT/run_tests

# Create the context file
sed -e "s\\^V3Test.compiler_output_dir=$\\V3Test.compiler_output_dir=$EXECROOT\\" -e "s\\^DejaGNUTest.target=$\\DejaGNUTest.target=$triplet\\" -e "s\\^VSX_NAME=$\\VSX_NAME=LSB Certification Version %{LSBSpec} (%{_target_cpu})\\" context.in > ${RPM_BUILD_ROOT}/$PKGROOT/context

find $LIBDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f
find $SHAREDIR -name '*.pyc' -o -name '*.pyo' -print0 | xargs -0 rm -f

# Make sure our build is good - past experience has had 
# missing .exe files, which isn't obvious when one runs the test
# (a missing exe gives a WARNING, not a FAIL)
sed -i "s|lib/libstdcpp|$archlib/libstdcpp|g" exe-files.txt
noexe=0
exelist=''
for exe in `grep -v '^#' exe-files.txt`; do 
  if [ ! -f ${RPM_BUILD_ROOT}/$exe ];then
    echo "Missing test $exe"
    noexe=`expr $noexe + 1`
    exelist="$exelist$exe\\n"
  fi
done
%if %{exefails}
  if [ "$noexe" -gt 0 ];then
    echo "Found $noexe missing .exe files, terminating build..."
    echo -e "Missing: \n$exelist"
    exit 1
  fi
%endif

# trim out any .cc files that do not have corresponding .exe files
# this way the runtime test result numbers will be more realistic
exedir="${RPM_BUILD_ROOT}/opt/lsb/test/$archlib/libstdcpp_%{version}"
ccdir="${RPM_BUILD_ROOT}/opt/lsb/test/libstdcpp_%{version}/testsuite"
for cc in `grep ": PASS" BUILD-DETAILS | grep '\.cc' | awk '{print $1}' | sed 's|:$||g' | sort | uniq`;do
  exe=`echo $cc | sed 's|/|_|g;s|\.cc|.exe|g'`
  exepath="$exedir/_$exe"
  if [ ! -f $exepath ];then                                                    
    echo "missing _$exe ... remove $cc";
    rm -f $ccdir/$cc
  fi;
done

# one test needs testsuite_shared.so, build/install it
cd testsuite
lsbc++ -fPIC -c testsuite_shared.cc
lsbc++ -shared -o testsuite_shared.so testsuite_shared.o
install testsuite_shared.so $exedir
cd ..

# see bug 2459 - disable for now
for source in 27_io/objects/char/12048-5.cc \
	27_io/objects/wchar_t/12048-5.cc \
	27_io/fpos/14320-1.cc ;do
  rm -f $ccdir/$source
done

for exe in _27_io_objects_char_12048-5.exe \
	_27_io_objects_wchar_t_12048-5.exe \
	_27_io_fpos_14320-1.exe ;do
  rm -f $exedir/$exe
done

# bug 2640 - spacing has changed upstream, just drop the test
for source in demangle/abi_examples/20.cc \
        demangle/abi_text/02.cc; do
  rm -f $ccdir/$source
done

for exe in demangle/abi_examples/20.exe \
        demangle/abi_text/02.exe; do
  rm -f $exedir/$exe
done

%clean
rm -rf $RPM_BUILD_ROOT

%post

%files
# Install all files as root:
%defattr(-,root,root)
/opt/lsb/test/libstdcpp_%{version}/
%ifarch ppc64 s390x x86_64
  /opt/lsb/test/lib64/libstdcpp_%{version}/
%else
  /opt/lsb/test/lib/libstdcpp_%{version}
%endif
%doc README
%doc README.%{name}
%doc PKGINFO
%doc BUILD-DETAILS
%doc executable-gen.qmr
%doc build_v3_dist
%doc build_binary_testsuite

%changelog
* Tue Aug 31 2010 Stew Benedict <stewb@linux-foundation.org>
- drop the lsbcc wrapper for ppc*, s390* - lngdbl support in place now
  see bugs 2884, 2450

* Fri Aug 27 2010 Stew Benedict <stewb@linux-foundation.org>
- bug 2943 - disable tests that fail on new distros and fail on old
  when patched to align with upstream (P7)

* Mon May 18 2009 Stew Benedict <stewb@linux-foundation.org>
- bug 2640 - several tests/subtests fail against 4.4.x
  upstream has changed the tests to accomodate, but new tests
  fail on older libstdc++ - drop tests/subtests (P5 + specfile)
  expected PASS drop to 1798 now

* Tue Apr 14 2009 Stew Benedict <stewb@linux-foundation.org>
- fix 22_locale/money_put/put/char/9780-3.cc against newer
  glibc (bug 2596, P4)

* Wed Feb 25 2009 Stew Benedict <stewb@linux-foundation.org>
- fix spec file issue with %%patch (bug 2537)

* Fri Dec 05 2008 Stew Benedict <stewb@linux-foundation.org>
- disable for now (bug 2459), test count to 1800:
  /27_io/fpos/14320-1.cc 1 FAIL
  /27_io/objects/char/12048-5.cc 1 FAIL
  /27_io/objects/wchar_t/12048-5.cc 1 FAIL
- fix (bug 2445, P3):
  /22_locale/time_put/put/char/4.cc 1
  /22_locale/time_put/put/char/wrapped_env.cc 1
  /22_locale/time_put/put/char/wrapped_locale.cc 1
  /22_locale/time_put/put/wchar_t/4.cc 1
  /22_locale/time_put/put/wchar_t/wrapped_env.cc 1
  /22_locale/time_put/put/wchar_t/wrapped_locale.cc 1

* Tue Jun 03 2008 Stew Benedict <stewb@linux-foundation.org>
- fix dg-xfail-if workaround - +9 tests to 1801
- turn back on 24_iterators/istreambuf_iterator/2.cc
- build/install testsuite_shared.so for a test - +1 to 1802

* Thu May 29 2008 Stew Benedict <stewb@linux-foundation.org>
- pick up another set of tests excluded before due to 
  dg-foo vs test harness - total is 1792 now

* Wed May 28 2008 Stew Benedict <stewb@linux-foundation.org>
- start trying to reclaim tests we lost in uplift
  filter out the dg-foo that our qm harness does not understand
- add %%shouldpass for expected count value (add 302, up to 1777 now)

* Fri May 23 2008 Stew Benedict <stewb@linux-foundation.org>
- picked up 30 tests just from header fixes

* Mon May 05 2008 Stew Benedict <stewb@linux-foundation.org>
- Uplift to 4.1.0 (bug 2087), new upstream tarball, redo patch
- add a list of tests (known-build-fails.txt) to skip even trying
  to build, to make diagnosing build failures a little easier
  (next step is to go back and reduce this list)
- move the compiler tests drop up front, before the build
- define %%knownfails, %%nocompiler and %%exefails to be able to 
  easily tune the build when we do an uplift or troubleshoot

* Mon Apr 28 2008 Stew Benedict <stewb@linux-foundation.org>
- Finalize bug 708 work (remove duplicate bits from bzr)

* Thu Apr 17 2008 Stew Benedict <stewb@linux-foundation.org>
- Build from upstream source (bug 708, S1, P2)

* Thu Feb 21 2008 Stew Benedict <stewb@linux-foundation.org>
- Move Version, LSBSpec, LSBRelease to Makefile only
- move %%post console messages to README.%{name} (bug 1940)

* Wed Apr 25 2007 Stew Benedict
- fix for ppc build (lsbc++ wrapper with -mlong-double-64)
- fix for ia64 build (no -include bits/stdc++.h)
- count .exe files as a sanity check for a "good" build
- refine packaged .cc files so test results reflect what we package

* Sat Mar 31 2007 Mats Wichmann <mats@freestandards.org>
- rename package to lsb-test-libstdcpp, note dependency is now lsb-qm

* Thu Jul 22 2004 Mats Wichmann <mats@freestandards.org>
- rollup changelog for various issues relating to LSB packaging,
  many from Hong Bo Peng
- created baselines for all LSB architectures
- modified v3_test.py to direct all LSB architectures to that set
- added packaging directory with specfile
- added prototype context file, and a run_tests script to execute

* Mon Apr 19 2004 Nathaniel Smith <njs@codesourcery.com> 
- Fix bug in computation of symbol baseline paths.
- Make package relocatable.
- Document generation of new symbol baseline files.
- Update QMTest-related URLs in README.

* Mon Mar 29 2004 Nathaniel Smith <njs@codesourcery.com> 
- Rework for no-compiler version of testsuite.

* Tue Mar 16 2004 Nathaniel Smith <njs@codesourcery.com> 
- Initial release.

